zoukankan      html  css  js  c++  java
  • Codeforces Round #363 (Div. 2) A、B、C

    A. Launch of Collider
    time limit per test
    2 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    There will be a launch of a new, powerful and unusual collider very soon, which located along a straight line. n particles will be launched inside it. All of them are located in a straight line and there can not be two or more particles located in the same point. The coordinates of the particles coincide with the distance in meters from the center of the collider, xi is the coordinate of the i-th particle and its position in the collider at the same time. All coordinates of particle positions are even integers.

    You know the direction of each particle movement — it will move to the right or to the left after the collider's launch start. All particles begin to move simultaneously at the time of the collider's launch start. Each particle will move straight to the left or straight to the right with the constant speed of 1 meter per microsecond. The collider is big enough so particles can not leave it in the foreseeable time.

    Write the program which finds the moment of the first collision of any two particles of the collider. In other words, find the number of microseconds before the first moment when any two particles are at the same point.

    Input

    The first line contains the positive integer n (1 ≤ n ≤ 200 000) — the number of particles.

    The second line contains n symbols "L" and "R". If the i-th symbol equals "L", then the i-th particle will move to the left, otherwise the i-th symbol equals "R" and the i-th particle will move to the right.

    The third line contains the sequence of pairwise distinct even integers x1, x2, ..., xn (0 ≤ xi ≤ 109) — the coordinates of particles in the order from the left to the right. It is guaranteed that the coordinates of particles are given in the increasing order.

    Output

    In the first line print the only integer — the first moment (in microseconds) when two particles are at the same point and there will be an explosion.

    Print the only integer -1, if the collision of particles doesn't happen.

    Examples
    input
    4
    RLRL
    2 4 6 10
    output
    1
    input
    3
    LLR
    40 50 60
    output
    -1
    Note

    In the first sample case the first explosion will happen in 1 microsecond because the particles number 1 and 2 will simultaneously be at the same point with the coordinate 3.

    In the second sample case there will be no explosion because there are no particles which will simultaneously be at the same point.

    思路:只有R找到最近的L,最近的;

    #include<bits/stdc++.h>
    using namespace std;
    #define ll __int64
    #define esp 0.00000000001
    const int N=2e5+10,M=1e6+10,inf=1e9+10,mod=1000000007;
    char a[N];
    int b[N];
    int main()
    {
        int x,y,z,i,t;
        scanf("%d",&x);
        scanf("%s",a);
        for(i=0;i<x;i++)
        scanf("%d",&b[i]);
        int pre=-1;
        int ans=inf;
        for(i=0;i<x;i++)
        {
            if(a[i]=='L'&&pre!=-1)
            ans=min((b[i]-pre)/2,ans);
            else if(a[i]=='R')
            pre=b[i];
        }
        if(ans!=inf)
            printf("%d
    ",ans);
            else
                printf("-1
    ");
        return 0;
    }
    B. One Bomb
    time limit per test
    1 second
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    You are given a description of a depot. It is a rectangular checkered field of n × m size. Each cell in a field can be empty (".") or it can be occupied by a wall ("*").

    You have one bomb. If you lay the bomb at the cell (x, y), then after triggering it will wipe out all walls in the row x and all walls in the column y.

    You are to determine if it is possible to wipe out all walls in the depot by placing and triggering exactly one bomb. The bomb can be laid both in an empty cell or in a cell occupied by a wall.

    Input

    The first line contains two positive integers n and m (1 ≤ n, m ≤ 1000) — the number of rows and columns in the depot field.

    The next n lines contain m symbols "." and "*" each — the description of the field. j-th symbol in i-th of them stands for cell (i, j). If the symbol is equal to ".", then the corresponding cell is empty, otherwise it equals "*" and the corresponding cell is occupied by a wall.

    Output

    If it is impossible to wipe out all walls by placing and triggering exactly one bomb, then print "NO" in the first line (without quotes).

    Otherwise print "YES" (without quotes) in the first line and two integers in the second line — the coordinates of the cell at which the bomb should be laid. If there are multiple answers, print any of them.

    Examples
    input
    3 4
    .*..
    ....
    .*..
    output
    YES
    1 2
    input
    3 3
    ..*
    .*.
    *..
    output
    NO
    input
    6 5
    ..*..
    ..*..
    *****
    ..*..
    ..*..
    ..*..
    output
    YES
    3 3

     思路:标记行列的墙,如果位置是墙会多加一,特判一下就好了;

    #include<bits/stdc++.h>
    using namespace std;
    #define ll __int64
    #define esp 0.00000000001
    const int N=1e3+10,M=1e6+10,inf=1e9+10,mod=1000000007;
    char a[N][N];
    int hang[N];
    int lie[N];
    int main()
    {
        int x,y,z,i,t;
        scanf("%d%d",&x,&y);
        for(i=1;i<=x;i++)
        for(t=1;t<=y;t++)
        cin>>a[i][t];
        int ans=0;
        for(i=1;i<=x;i++)
        for(t=1;t<=y;t++)
        {
            if(a[i][t]=='*')
            {
                hang[i]++;
                lie[t]++;
                ans++;
            }
        }
        for(i=1;i<=x;i++)
        for(t=1;t<=y;t++)
        {
            int gg=hang[i]+lie[t];
            if(a[i][t]=='*')
                gg--;
            if(gg>=ans)
            {
                printf("YES
    ");
                printf("%d %d",i,t);
                return 0;
            }
        }
        printf("NO
    ");
        return 0;
    }
    C. Vacations
    time limit per test
    1 second
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    Vasya has n days of vacations! So he decided to improve his IT skills and do sport. Vasya knows the following information about each of this n days: whether that gym opened and whether a contest was carried out in the Internet on that day. For the i-th day there are four options:

    1. on this day the gym is closed and the contest is not carried out;
    2. on this day the gym is closed and the contest is carried out;
    3. on this day the gym is open and the contest is not carried out;
    4. on this day the gym is open and the contest is carried out.

    On each of days Vasya can either have a rest or write the contest (if it is carried out on this day), or do sport (if the gym is open on this day).

    Find the minimum number of days on which Vasya will have a rest (it means, he will not do sport and write the contest at the same time). The only limitation that Vasya has — he does not want to do the same activity on two consecutive days: it means, he will not do sport on two consecutive days, and write the contest on two consecutive days.

    Input

    The first line contains a positive integer n (1 ≤ n ≤ 100) — the number of days of Vasya's vacations.

    The second line contains the sequence of integers a1, a2, ..., an (0 ≤ ai ≤ 3) separated by space, where:

    • ai equals 0, if on the i-th day of vacations the gym is closed and the contest is not carried out;
    • ai equals 1, if on the i-th day of vacations the gym is closed, but the contest is carried out;
    • ai equals 2, if on the i-th day of vacations the gym is open and the contest is not carried out;
    • ai equals 3, if on the i-th day of vacations the gym is open and the contest is carried out.
    Output

    Print the minimum possible number of days on which Vasya will have a rest. Remember that Vasya refuses:

    • to do sport on any two consecutive days,
    • to write the contest on any two consecutive days.
    Examples
    input
    4
    1 3 2 0
    output
    2
    input
    7
    1 3 3 2 1 2 3
    output
    0
    input
    2
    2 2
    output
    1
    Note

    In the first test Vasya can write the contest on the day number 1 and do sport on the day number 3. Thus, he will have a rest for only 2 days.

    In the second test Vasya should write contests on days number 1, 3, 5 and 7, in other days do sport. Thus, he will not have a rest for a single day.

    In the third test Vasya can do sport either on a day number 1 or number 2. He can not do sport in two days, because it will be contrary to the his limitation. Thus, he will have a rest for only one day.

     思路:简单dp;

       dp[i][t]表示第i天,休息或者打比赛,或者锻炼的最小浪费天数;

    #include<bits/stdc++.h>
    using namespace std;
    #define ll __int64
    #define esp 0.00000000001
    const int N=1e3+10,M=1e6+10,inf=1e9+10,mod=1000000007;
    int a[N];
    int dp[N][5];
    int main()
    {
        int x,y,z,i,t;
        scanf("%d",&x);
        for(i=1;i<=x;i++)
        scanf("%d",&a[i]);
        for(i=1;i<=x;i++)
        {
            dp[i][1]=min(dp[i-1][1],min(dp[i-1][2],dp[i-1][3]))+1;
            if(a[i]+1==1)
            {
                dp[i][2]=inf;
                dp[i][3]=inf;
            }
            else if(a[i]+1==2)
            {
                dp[i][2]=min(dp[i-1][1],dp[i-1][3]);
                dp[i][3]=inf;
            }
            else if(a[i]+1==3)
            {
                dp[i][2]=inf;
                dp[i][3]=min(dp[i-1][1],dp[i-1][2]);
            }
            else
            {
                dp[i][2]=min(dp[i-1][1],dp[i-1][3]);
                dp[i][3]=min(dp[i-1][1],dp[i-1][2]);
            }
        }
        printf("%d
    ",min(dp[x][1],min(dp[x][2],dp[x][3])));
        return 0;
    }

    附我gou贪心代码

    #include <iostream>
    #include <cstdio>
    #include <cmath>
    #include <string>
    #include <cstring>
    #include <algorithm>
    #include <queue>
    #include <map>
    #include <set>
    #include <stack>
    #include <sstream>
    #include <vector>
    #define PI acos(-1.0)
    const int  inf =  (1<<30) - 10;
    using namespace std;
    inline int get_int()
    {
        int r=0;
        char c;
        while((c=getchar())!=' '&&c!='
    ')
            r=r*10+c-'0';
        return r;
    }
    inline void out(int x)
    {
        if(x>10)
        {
            out(x/10);
        }
        putchar(x % 10 + '0');
        putchar('
    ');
    }
    /****************************************/
    int a[200];
    int main()
    {
        int n,m;
        cin>>n;
        for(int i=0;i<n;i++){
            scanf("%d",&a[i]);
        }
        m=0;
        if(a[0]>0){
            m++;
        }
        if(a[0]==3)
            a[0]=0;
        for(int i=1;i<n;i++){
            if(a[i]==1){
                if(a[i-1]!=1)
                   m++;
                else a[i]=0;
            }
            if(a[i]==2){
                if(a[i-1]!=2)
                   m++;
                else a[i]=0;
            }
            if(a[i]==3){
                if(a[i-1]==1){
                    a[i]=2;
                    m++;
                }
                if(a[i-1]==2){
                    a[i]=1;
                    m++;
                }
                if(a[i-1]==0){
                    a[i]=0;
                    m++;
                }
            }
        }
        printf("%d
    ",n-m);
        return 0;
    }
  • 相关阅读:
    一分钟教你解决前端分流问题
    win7 mysql 数据库轻松实现数据库定时备份
    mysql 修改密码
    what is yaml ?
    php实现监控在线服务应用程序小栗子
    Python装饰器小代码
    2,构造代码块
    1,匿名对象,封装
    7,random
    测试错题
  • 原文地址:https://www.cnblogs.com/jhz033/p/5687575.html
Copyright © 2011-2022 走看看